# Changelog

## 2.6.0

- Bug fixes
- Added support for getShareOfHousingAssociationNetDebt

## 2.5.1

- Minor bug fixes

## 2.5.0

- Redesigned and refactored the deal view.
- Moved user CSS and Bootstrap to the theme.
- Allow float numbers for areas and rooms (e.g. 51.2 sqm and 3.5 rooms). These were previously rounded up.
- Fixed issues with some bidding settings like *Show only current bid*, *Show bidding active* and enabling bidding for farming and commercial objects.
- Fixed a bug in the function that converts sqm to hectares.
- Sorted the economy facts in the economy view and removed some duplicated facts.
- Fixed the search field.
- Viewing fixes
  - Added support for the viewing type that only shows a viewing comment.
  - Added support for the booking form for viewing type with only a date (no time)
  - Added support for the comment field for viewing type *Show contact the broker for viewing* (the comment now replaces the default message if you write a comment)

## New Breaking changes

- The assisstants view file is now **deprecated**. The reason for it is that
it's almost identical to the broker view file. The broker view file has
been changed to be used for both assistants and brokers. The view file
will be removed in the future
- The view files have been fully refactored

## New Changes

- Values displayed in hectare are displayed with 4 decimals
- Hectare is now used on all areas for farming objects
- Manually added names for housing associations are now displayed
- Premises for sale listed as reference objects can no longer be clicked
- Storage description on tenant ownership are now displayed

## 2.4.2

### Bugs

- Development projects now update their list of objects
- Version is now correctly appended to query urls

## 2.4.0

- Requests can now be logged via a option in the settings page
- Error handling has been improved
- Database tables are automatically being updated
- PHPMailer has been updated to v6.0
- The unit for plot and water area for farming is now hectare instead of square meters
- New fields have been added to object description for houses in development
- Reference objects are now sorted by contract date by default
- The main image for the deal is now used instead of the main image for the estate
in the object listing
- Reference objects can no longer be accessed via an old link
- Made the plugin compatible with Wordpress 5 and gutenberg
- If no mortgages exists on a comercial object, the object
description will now say that no mortgages exist
- Other income on commercial objects is now shown

### Bugs

- New settings not being shown has been fixed
- Multiline translations can now be interpreted
- Fix bug which caused an error when manually updating translations
- Show the default picture correctly in `brokers` view

## 2.3.0

- Viewings can now be booked
- Foreign currencies are now shown in the object listing and object description
- Dependencies are now installed with composer
- Added cost description under economy section
- Added property tax under economy section
- Added primary energy performance to object description
- Added radon comment to object description
- Added ground rent to object description
- Added joist type to object description
- Added Premise rent is negotiable object description


*Versions prior to 2.3.0 were not documented*
