<?php
/**
 * Created by PhpStorm.
 * User: rasulniyazimbetov
 * Date: 05/02/15
 * Time: 17:47
 */

class Conf {   
    private $config;

    public function __construct(){
        global $wpdb;
        $tableName = $wpdb->prefix . "config";

        $this->config = $wpdb->get_row("Select * from $tableName");
    }

    final public function get() {
        return array(
            'encryptionKey' => $this->getProperty("encryptionKey"),
            'internalToken' => $this->getProperty("internalToken"),
            'mailer' => array(
                //email server config
                'server' => $this->getProperty("server"),
                'port' => $this->getProperty("port"),
                'username' => $this->getProperty("username"),
                'password' => $this->getProperty("password"),
                'charSet' => $this->getProperty("charSet"),
                'SMTPSecure' => $this->getProperty("SMTPSecure"),
                'SMTPAuth' => $this->getProperty("SMTPAuth"),
            ),
            'googleStaticMapKey' => $this->getProperty("googleStaticMapKey"),
            'useGoogleCaptcha' => $this->getProperty("useGoogleCaptcha"),
            'googleCaptcha' => array(
                'secretKey' => $this->getProperty("secretKey"),
                'siteKey' => $this->getProperty("siteKey"),
            )
        );
    }

    private function getProperty(string $propertyName){
        if(isset($this->config->{$propertyName}))
            return $this->config->{$propertyName};
        
        //This will happen if no row exists in config and acts as a default
        if($propertyName == "useGoogleCaptcha" || $propertyName == "SMTPAuth")
            return false;
        else
            return "";
    }
}
