/*! Mspecs plugin - v3.0.0
 * www.mspecs.se
 * Copyright (c) 2015; * Licensed GPLv2+ */

(function(jQuery){
    jQuery(document).ready(function(){
        //button load more
        jQuery('body').on('click', '.mspecs_load-more', function(){

            var container = jQuery(this);
            var event = container.attr('data-event');
            var url = jQuery(this).attr('href');

            container.addClass('loading');

            jQuery.ajax({
                "complete": function(){
                    container.removeClass('loading');
                },
                "data": container.data('params') || {},
                "dataType": "json",
                "success": function(data){
                    if(data.status == 'success' && data.content){
                        var content = jQuery('<div>').html(data.content).insertBefore(container);
                        jQuery(window).trigger(event || 'load-page', [content, url]);
                        content.children().unwrap();
                        container.remove();
                    } else if(data.status == 'error' && data.message){
                        alert(data.message);
                    } else {
                        console.log(data);
                    }
                },
                "type": "post",
                "url": url
            });
            return false;
        });

        //set block display for pre tag li s
        jQuery("li").each(function() {
            if(jQuery(this).children('pre').length>0) {
                jQuery(this).css('display', 'block');
            }
        });

        if(jQuery('li:has(> pre)')) {
            jQuery(this).css('display', 'block');
        } else {
            jQuery(this).css('display', 'inline-flex');
        }

        //bidding on deal page
        jQuery('.mspecs-wp-show-bidding-modal').on('click', function(e) {
            e.preventDefault();

            // Handle scroll bar (set padding on body if there is a scroll bar to prevent page jumping)
            var documentWidth = document.documentElement.clientWidth;
            var windowWidth = window.innerWidth;
            var scrollBarWidth = windowWidth - documentWidth;

            document.body.style.padding = "0px " + scrollBarWidth + "px 0px 0px";

            // Hide back to top button when enabling modal
            backToTopButton.style.display = "none";

            // Add class to body to prevent background scrolling
            jQuery("body").addClass('mspecs-wp-modal-active');

            jQuery('#mspecs-wp-bidding-modal').addClass('active');
        });

        jQuery(".bookingbtn").click(function(e) {
            e.preventDefault();

            // Handle scroll bar (set padding on body if there is a scroll bar to prevent page jumping)
            var documentWidth = document.documentElement.clientWidth;
            var windowWidth = window.innerWidth;
            var scrollBarWidth = windowWidth - documentWidth;

            document.body.style.padding = "0px " + scrollBarWidth + "px 0px 0px";

            // Hide back to top button when enabling modal
            backToTopButton.style.display = "none";

            // Add class to body to prevent background scrolling
            jQuery("body").addClass('mspecs-wp-modal-active');

            var booking = jQuery('#bookingForm');
            //get id of button
            var ids = jQuery(this).attr('id').split('__');
            var viewingId = ids[0];
            var slotId = ids[1];
            //get booking time title
            var title = jQuery(this).attr('title');
            var time = jQuery(this).attr('data-time');
            //add value to hidden element
            //time = time ? ', ' + time : '';

            // Reset bookingTime container
            jQuery("#bookingTime").empty();

            // Append slot select to modal
            var slotSelect = jQuery(this).parents('.mspecs-wp-viewing-info-slots').find('.mspecs-wp-viewing-slot-select');
            if(slotSelect.length) {
                var slotSelectClone = slotSelect.clone();
                slotSelectClone.show().appendTo("#bookingTime");
                slotSelectClone.addClass('active');
            }
            else {
                jQuery("#bookingTime").append(" " + time);
            }

            jQuery("#viewing_id").val(viewingId);

            jQuery("#bookingTitle").html(title);

            jQuery("#bookingForm").addClass('active');
        });

        // Close modal and reset modal form if form exists
        jQuery(".mspecs-wp-modal-overlay, .mspecs-wp-modal-close-button").click(function(e) {
            e.preventDefault();

            // Reset body class to reenable body scrolling
            jQuery("body").removeClass('mspecs-wp-modal-active');

            // Reset body padding (handle scrollbar)
            document.body.style.padding = "0px 0px 0px 0px";

            // Reset back to top button
            backToTopButton.style.display = "inline-block";

            // Hide the modal
            var modal = jQuery(this).parents('.mspecs-wp-modal-container');
            modal.removeClass('active');

            // Reset success message
            modal.find('.mspecs-wp-viewing-form-success').removeClass('active');

            // Reset form
            modal.find('input[type=checkbox]').prop('checked', false);
            modal.find('.mspecs-wp-input-text').val('');
        });

        //search
        jQuery(".mspecs-wp-searchbox").on("keyup", function() {
            var value = jQuery(this).val().toLowerCase();
            jQuery("#main-content").find(".estate").filter(function() {
                jQuery(this).toggle(jQuery(this).text().toLowerCase().indexOf(value) > -1)
            });
        });
    });
})(jQuery);

// Scroll to element (for shortcuts menu)
function scrollTo(element) {
    window.scroll({
        behavior: 'smooth',
        left: 0,
        top: element.offsetTop - 100
    });
}

// missing forEach on NodeList for IE11
if (window.NodeList && !NodeList.prototype.forEach) {
    NodeList.prototype.forEach = Array.prototype.forEach;
}

var shortCutLinks = document.getElementsByClassName("mspecs-wp-shortcuts-link");
Array.from(shortCutLinks).forEach(function(element) {
    element.addEventListener('click', function(e) {
        e.preventDefault();

        // Reset active states for shortcuts
        Array.from(shortCutLinks).forEach(function(shortcut) {
            shortcut.classList.remove("active");
        });

        // Set active state for shortcut
        element.classList.add("active");

        scrollTo(document.getElementById(element.getAttribute("data-anchor")));
    });
});

// Added observer for handling box-shadow for the shortcut menu
// There's currently no native CSS solution for knowing when an
// element is actually sticky.
const stickyShortcuts = document.querySelector('.mspecs-wp-shortcuts-sticky');
const observer = new IntersectionObserver(
  ([e]) => e.target.classList.toggle('shadow', e.intersectionRatio < 1),
  {threshold: [1]}
);
if(stickyShortcuts) {
    observer.observe(stickyShortcuts);
}

// Enable scroll back to top button
// And show/hide scroll back to top
var backToTopButton = document.getElementById("mspecs-wp-backtotop");

if(backToTopButton) {
    backToTopButton.addEventListener('click', function(e) {
        e.preventDefault();

        window.scroll({
            behavior: 'smooth',
            left: 0,
            top: 0
        });
    });

    var backToTopScroll = function () {
        var y = window.scrollY;
        if (y >= 800) {
            backToTopButton.className = "mspecs-wp-backtotop active";
        } else {
            backToTopButton.className = "mspecs-wp-backtotop";
        }
    };

    window.addEventListener("scroll", backToTopScroll);
}

// Enable/disable send button in interest form when all mandatory fields are valid
var interestFirstName = document.getElementById('interest-firstname');
var interestLastName = document.getElementById('interest-lastname');
var interestEmail = document.getElementById('interest-email');
var interestPhone = document.getElementById('interest-phone');
var interestGDPR = document.getElementById('interest-gdpr');
var interestSubmit = document.getElementById('email-button');
var interestFields = [interestFirstName, interestLastName, interestEmail, interestPhone, interestGDPR];
var interestFieldsValid = false;

// Function that checks if all mandatory fields are valid or not
// Sets submit button disabled status accordingly
var checkInterestFormFieldValidity = function(inputs) {
    interestFieldsValid = true;

    interestFields.forEach(function(inputs) {
        if(!inputs.checkValidity()) {
            interestFieldsValid = false;
        }
    });

    if(interestFieldsValid) {
        interestSubmit.disabled = false;
    }
    else {
        interestSubmit.disabled = true;
    }
}

// Set up event listeners on interest form fields
interestFields.forEach(function(element) {
    if(element) {
        window.addEventListener('keyup', checkInterestFormFieldValidity, false);
        window.addEventListener('change', checkInterestFormFieldValidity, false);
    }
});

// Enable/disable send button in booking form when all mandatory fields are valid
var bookingFirstName = document.getElementById('booking-firstname');
var bookingLastName = document.getElementById('booking-lastname');
var bookingEmail = document.getElementById('booking-email');
var bookingPhone = document.getElementById('bookingPhone');
var bookingGDPR = document.getElementById('booking-gdpr');
var bookingSubmit = document.getElementById('booking-button');
var bookingFields = [bookingFirstName, bookingLastName, bookingEmail, bookingPhone, bookingGDPR];
var bookingFieldsValid = false;

// Function that checks if all mandatory fields are valid or not
// Sets submit button disabled status accordingly
var checkBookingFormFieldValidity = function(inputs) {
    bookingFieldsValid = true;

    bookingFields.forEach(function(inputs) {
        if(!inputs.checkValidity()) {
            bookingFieldsValid = false;
        }
    });

    if(bookingFieldsValid) {
        bookingSubmit.disabled = false;
    }
    else {
        bookingSubmit.disabled = true;
    }
}

// Set up event listeners on interest form fields
bookingFields.forEach(function(element) {
    if(element) {
        window.addEventListener('keyup', checkBookingFormFieldValidity, false);
        window.addEventListener('change', checkBookingFormFieldValidity, false);
    }
});
