document.addEventListener("DOMContentLoaded", function(){
    initCheckbox("SMTPAuth", ["configUsername", "configPassword"]);
    initCheckbox("useGoogleCaptcha", ["secretKey", "siteKey"]);
});

function toggleInputs(inputIds){
    inputIds.forEach(inputId => {
        input = document.getElementById(inputId);
        input.disabled = !input.disabled;
        input.style.transition = "all .1s";

        const inputLabel = input.parentElement.previousElementSibling;
        inputLabel.style.opacity = input.disabled ? 0.4 : 1;
        inputLabel.style.transition = "opacity .1s";
    });
}

function initCheckbox(checkboxId, inputIdsToToggle){
    const checkbox = document.getElementById(checkboxId);
    checkbox.addEventListener("change", function(event){
        toggleInputs(inputIdsToToggle);
    });

    //Inputs are assumed to be enabled by default
    if(!checkbox.checked)
        toggleInputs(inputIdsToToggle);
}