<?php

class Mspecs_Controllers_Admin_Settings extends Mspecs_Controller
{

    public function __construct()
    {
        add_action('admin_menu', array($this, 'registerAdminMenu'));
    }

    public function registerAdminMenu()
    {
        add_options_page('MSPECS API Settings', 'MSPECS API', 'administrator', 'mspecsapi', array($this, 'settingsMenu'));
    }

    public function settingsMenu()
    {
        if (!current_user_can('manage_options')) {
            wp_die(__('You do not have sufficient permissions to access this page.'));
        }

        wp_enqueue_script("settingsPage:js", MSPECS_PLUGIN_URL . 'includes/settingsPage.js');

        if (sizeof($_POST) > 0) {
            if (isset($_POST['clear-cache'])) {
                MSPECS::getCache()->clearCache();
            } elseif (isset($_POST["update-language"])){
                Translation::createTranslationFiles();
            } elseif (isset($_POST['clear-files'])) {
                MSPECS::getCache()->clearFiles();
            } elseif (isset($_POST['settings'])) {
                if(MSPECS::apiCredidentialsExists($_POST['api-link'], $_POST['username'], $_POST['password'])){
                    MSPECS::setOption('username', !empty($_POST['username']) ? $_POST['username'] : '');
                    MSPECS::setOption('password', !empty($_POST['password']) ? $_POST['password'] : '');
                    MSPECS::setOption('api-link', !empty($_POST['api-link']) ? $_POST['api-link'] : '');
                    MSPECS::setOption('api-page', !empty($_POST['api-page']) ? $_POST['api-page'] : '');

                    //setting db params
                    MSPECS::setParam('username', !empty($_POST['username']) ? $_POST['username'] : '');
                    MSPECS::setParam('password', !empty($_POST['password']) ? $_POST['password'] : '');
                    MSPECS::setParam('link', !empty($_POST['api-link']) ? $_POST['api-link'] : '');
                
                    //Store the config in the database
                    $config = $_POST["config"];
                    MSPECS::setConfig($config);

                    //Check if the entered credidentials are correct
                    $api = MSPECS::getApi();
                    $connection = $api->_getConnection();

                    curl_setopt($connection, CURLOPT_URL, $_POST["api-link"] . (substr($_POST["api-link"], -1) == "/" ? "deals" : "/deals"));
                    curl_setopt($connection, CURLOPT_USERPWD, $_POST["username"] . ":" . $_POST["password"]);

                    if($response = json_decode(curl_exec($connection))){
                        if(isset($response[0]) && isset($response[0]->status)){
                            echo "<div class='notice notice-error'><p>Dina inloggningsuppgifter är felaktiga</p></div>";
                        }
                        else{
                            echo "<div class='notice notice-success'><p>Inloggningen lyckades</p></div>";
                        }
                    }
                    else{
                        if(defined('WP_DEBUG') && WP_DEBUG)
                            echo "<div class='notice notice-error'><p>" . curl_error($connection) . "</p></div>";
                        else
                            echo "<div class='notice notice-error'><p>Kunde inte ansluta till servern</p></div>";
                    }
                }
                else
                    echo "<div class='notice notice-error'><p>Du måste fylla i <b>Api Länk, användarnamn och lösenord</b></p></div>";
            }
        }

        echo $this->_renderView('admin/settings', array(
            'pages' => get_pages(array('hierarchical' => 0, 'parent' => 0))
        ));
    }

}

$settingsController = new Mspecs_Controllers_Admin_Settings();