<?php

class Mspecs_Model_Bidding extends Mspecs_Model
{
    public function getCurrentHighestBid()
    {
        //Gets all the active bids and chooses the one with the higest price
        if($bids = $this->getBids("'ENUMS_BID_STATUS_ACTIVE'")) {
            return $bids[0]->getBidAmount();
        }
        return null;
    }

    //Filters out bids depending on their status
    public function filterBids($status = "'ENUMS_BID_STATUS_ACTIVE','ENUMS_BID_STATUS_REVOKED'"){
        return array(
            'path' => 'bids',
            'query' => array(
                'q' => "biddingId='{$this->getId()}' AND isPrivate=false AND status IN ({$status})",
                'sort' => "-bidAmount,-bidDate"
            ),
        );
    }

    public function getBidders() {
        $query = array(
            'path' => 'bidders',
            'query' => array(
                'q' => "biddingId='{$this->getId()}'"
            ),
        );

        if($bidders = $this->_getApi()->query($query)) {
            $collection = new Mspecs_Collection($bidders);
            return $collection;
        }
        return null;
    }
        
    public function getBids($filterCriteria = '') {
        $query = $filterCriteria ? $this->filterBids($filterCriteria) : $this->filterBids();
        $bids = array();

        if($data = $this->_getApi()->query($query)) {
            if($bidders = $this->getBidders()) {
                if(is_array($data))
                    foreach($data as $bidData) {
                        foreach($bidders as $bidder) {
                            if(strcmp ( $bidData['bidderId'] , $bidder['id']) == 0) {
                                $bidData['bidderStatus'] = $bidder['status'];
                            }
                        }
                        $bids[] = new Mspecs_Model_bid($bidData);
                    }
                $collection = new Mspecs_Collection($bids);
                return $collection;
            }
        }

        return null;
    }
}
