<?php
/**
 * Created by PhpStorm.
 * User: rasulniyazimbetov
 * Date: 09/06/14
 * Time: 14:52
 */

class Mspecs_Model_Building extends Mspecs_Model {

    protected $_buildingTypeEnums = null;
    protected $_parent = null;

    public function getBuildingTypeEnum() {

      if (!$this->_buildingTypeEnums) {
        $query = array(
            'path' => 'buildingTypes',
            'query' => array(
                'q' => "id='{$this->getBuildingTypeId()}'"
            ),
        );
        $this->_buildingTypeEnums = $this->_getApi()->queryOne($query)['name'];
      }

      return $this->_buildingTypeEnums;
    }

    public function getParent() {
        if (!$this->getParentId()) {
            return null;
        }

        if (!$this->_parent) {
            $query = array(
            'path' => 'buildings',
            'query' => array(
                'q'=> "id='{$this->getParentId()}'"
            ));
            $parentData = $this->_getApi()->queryOne($query);
            if (is_array($parentData)) {
                $this->_parent = new Mspecs_Model_Building($parentData);
            }
        }

        return $this->_parent;
    }

    public function getParentName() {
        if ($parent = $this->getParent()) {
            return $parent->getName();
        }
        return null;
    }

    public function getOperatingCostAmounts() {
        $query = array(
            'path' => 'buildingOperatingCosts',
            'query' => array(
                'q' => "buildingId='{$this->getId()}'"
                ),
            );

        if($data = $this->_getApi()->query($query)) {
            if(is_array($data)) {
                //get amounts by costs
                $amountIds = array_map(function($cost) {
                    return $cost['amountId'];
                }, $data);

                if(!empty($amountIds)) {
                    $query = array(
                        'path' => 'amounts',
                        'query' => array(
                            'q' => "id IN ('" . join("','", $amountIds) . "')"),
                        );
                    if($amounts = $this->_getApi()->query($query)) {
                        $amountsList = array();
                        if(is_array($amounts) && !empty($amounts)) {
                            foreach ($amounts as $key => $value) {
                                $amountsList[] = new Mspecs_Model_Amount($value);
                            }
                        }
                        return new Mspecs_Collection($amountsList);
                    }
                }
            }
        }
        return null;
    }

    public function showOnlyComment() {
      if ($this->getBuildingTypeEnum() == 'ENUM_BUILDING_TYPE_ECONOMI') {
        return $this->getShowOnlyCommentInObjectDescription();
      } else if ($this->getBuildingTypeEnum() == 'ENUM_BUILDING_TYPE_HOUSE_FARMING') {
        return $this->getShowOnlyBuildingCommentInObjectDescription();
      }
      return null;
    }

    public function inMonth($amount) {
        return round($amount / 12);
    }

    public function inYear($amount) {
        return round($amount * 12);
    }
}
