<?php

class Mspecs_Model_File extends Mspecs_Model
{

    protected $_loaded = false;

    public function __construct($data = null)
    {
        if (is_array($data)) {
            parent::__construct($data);
        } elseif ($data) {
            parent::__construct(array('fileId' => $data));
        }
    }

    public function getUrl($reload = false)
    {
        //do not load any files besides images
        if(!$this->load()->getIsImage()) {
            if ($url = $this->load()->getOriginalURI()) {
                //return $url;
                return MSPECS::getCache()->getFileUrl($url, $reload);
            }
        } else {
            if ($url = $this->load()->getViewURI()) {
                return MSPECS::getCache()->getFileUrl($url, $reload);
            }
        }

        return '';
    }

    public function getCategory()
    {
        if ($this->getFileCategoryId()) 
            return $category = $this->_getApi()->getFileCategory($this->getId());
        
        return "";
    }

    public function load()
    {
        if (!$this->_loaded) {
            if ($file = $this->_getApi()->getFileById($this->getFileId(), false)) {
                $this->addData($file->getData());
                $this->_loaded = true;
            }
        }
        return $this;
    }

    public function __toString()
    {
        return $this->getUrl();
    }

}