<?php

class Mspecs_Model_Visit extends Mspecs_Model
{
    public $slots = array();

    public function getStartDate($format = 'M j, Y H:i')
    {
		date_default_timezone_set('Europe/Stockholm');
		setlocale(LC_TIME, "sv_SE.UTF-8");
        if ($date = $this->getData('startDate')) {
            return date($format, strtotime($date));
        }
        return null;
    }

    // Temporary fix for making setlocale work
    // setlocale doesn't work with date() so it doesn't work in getStartDate()
    // All date functions here should be refactored and updated in the view files
    public function getStartDateWithLocale($format = '%b %e, %Y %H:%M')
    {
		date_default_timezone_set('Europe/Stockholm');
		setlocale(LC_TIME, "sv_SE.UTF-8");
        if ($date = $this->getData('startDate')) {
            $timespan = strtotime($date);
            return strftime($format, $timespan);
        }
        return null;
    }

	public function getStartDateOnly($format = '%e %B, %G')
    {
		date_default_timezone_set('Europe/Stockholm');
		setlocale(LC_TIME, "sv_SE");
        if ($date = $this->getData('startDate')) {
			$timespan = strtotime($date);
            return strftime($format, $timespan);
        }
        return null;
    }

	public function getStartTime($format = 'H:i')
    {
		date_default_timezone_set('Europe/Stockholm');
		setlocale(LC_TIME, "sv_SE.UTF-8");
        if ($date = $this->getData('startDate')) {
			$h = date('H', strtotime($date));
			$m = date('i', strtotime($date));
			if($h==0 && $m==0) {
				return null;
			}
            return date($format, strtotime($date));
        }
        return null;
    }

	public function getEndTime($format = 'H:i')
    {
		date_default_timezone_set('Europe/Stockholm');
		setlocale(LC_TIME, "sv_SE.UTF-8");
        if ($date = $this->getData('endDate')) {
            $h = date('H', strtotime($date));
			$m = date('i', strtotime($date));
			if($h==0 && $m==0) {
				return null;
			}
            return date($format, strtotime($date));
        }
        return null;
    }

}